/**********************************************************************
Copyright (C) 2016 Rainbeau Flambe (Darryl Burgdorf)

This program is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the Free 
Software Foundation, either version 3 of the License, or (at your option) 
any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details.

You should have received a copy of the GNU General Public License along 
with this program.  If not, see <http://www.gnu.org/licenses/>
**********************************************************************/

package rainbeau.mithwoodforest;

import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import rainbeau.mithwoodforest.RMFConfig.Config;
import rainbeau.mithwoodforest.RMFProxies.ProxyCommon;

@Mod(
	modid = "mithwoodforest", 
	name = "Rainbeau's MithwoodForest", 
	version = "RMF1.02", 
	guiFactory="rainbeau.mithwoodforest.RMFConfig.ConfigGUIFactory", 
	dependencies = "required-after:Forge@[12.18.1.2011,)",
	acceptedMinecraftVersions="1.10.2"
)

public class MithwoodForest {

	@Mod.Instance("mithwoodforest")
	public static MithwoodForest instance;
	
	@SidedProxy(clientSide="rainbeau.mithwoodforest.RMFProxies.ProxyClient", serverSide="rainbeau.mithwoodforest.RMFProxies.ProxyCommon")
	public static ProxyCommon proxy;
	
	public static Configuration configFile;

	@Mod.EventHandler
	public void preInit(FMLPreInitializationEvent event) {
		System.out.println("Growing Rainbeau's Mithwood Forest...!");
	    configFile = new Configuration(event.getSuggestedConfigurationFile());
		Config.init();
		this.proxy.preInit(event);
	}

	@Mod.EventHandler
	public void init(FMLInitializationEvent event) {
		this.proxy.init(event);
	}

	@Mod.EventHandler
	public void postInit(FMLPostInitializationEvent event) {
		this.proxy.postInit(event);
	}

}
