package rainbeau.mithwoodforest.RMFBlocks;

import java.util.Random;

import net.minecraft.block.BlockDoor;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import rainbeau.mithwoodforest.RMFConfig.Config;

public class BlockMithwoodDoor extends BlockDoor {  

	private Item doorItem;
    
    public BlockMithwoodDoor() {
        super(Material.WOOD);
        this.setHardness(3.0F);
        this.setSoundType(SoundType.WOOD);
    }
    
    public void setDoorItem(Item doorItem) {
        this.doorItem = doorItem;
		if (Config.GrowMithwoodForest == true) {
			GameRegistry.addRecipe(new ItemStack(this.doorItem, 3), new Object[] { "PP ", "PP ", "PP ", 'P', BlocksCreate.mithwood_plank });
		}
    }
    
    public Item getDoorItem() {
        return this.doorItem == null ? Items.OAK_DOOR : this.doorItem;
    }
    
    @Override
    @SideOnly(Side.CLIENT)
    public ItemStack getPickBlock(IBlockState state, RayTraceResult target, World world, BlockPos pos, EntityPlayer player) {
        return new ItemStack(this.getDoorItem(), 1);
    }
    
    @Override
    public Item getItemDropped(IBlockState state, Random rand, int fortune) {
        return state.getValue(HALF) == EnumDoorHalf.UPPER ? null : this.getDoorItem();
    }
    
}
