package rainbeau.mithwoodforest.RMFBlocks;

import net.minecraft.block.BlockFenceGate;
import net.minecraft.block.BlockPlanks;
import net.minecraft.block.BlockWall;
import net.minecraft.block.SoundType;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;

public class BlockMithwoodFenceGate extends BlockFenceGate {
	
	public BlockMithwoodFenceGate() {
		super(BlockPlanks.EnumType.BIRCH);
		this.setUnlocalizedName("mithwood_fencegate");
		this.setHardness(1.75F);
		this.setResistance(4.75F);
		this.setSoundType(SoundType.WOOD);
		this.setHarvestLevel("axe", 0);
		this.setCreativeTab(CreativeTabs.DECORATIONS);
	}

	@Override
    public IBlockState getActualState(IBlockState state, IBlockAccess worldIn, BlockPos pos) {
		EnumFacing.Axis enumfacing$axis = ((EnumFacing)state.getValue(FACING)).getAxis();
        if (enumfacing$axis == EnumFacing.Axis.Z && 
       		(worldIn.getBlockState(pos.west()).getBlock() instanceof BlockWall || worldIn.getBlockState(pos.east()).getBlock() instanceof BlockWall) 
       		|| enumfacing$axis == EnumFacing.Axis.X && 
       		(worldIn.getBlockState(pos.north()).getBlock() instanceof BlockWall || worldIn.getBlockState(pos.south()).getBlock() instanceof BlockWall)) {
        	state = state.withProperty(IN_WALL, Boolean.valueOf(true));
        }
        return state;
    }

}
