package rainbeau.mithwoodforest.RMFBlocks;

import net.minecraft.block.Block;
import net.minecraft.block.BlockPlanks;
import net.minecraft.block.BlockSlab;
import net.minecraft.block.material.Material;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemDoor;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.common.registry.GameRegistry;
import rainbeau.mithwoodforest.MithwoodForest;
import rainbeau.mithwoodforest.RMFItems.ItemMithwoodSlab;
import rainbeau.mithwoodforest.RMFItems.ItemsCreate;

public class BlocksCreate {

	public static Block unobtainium_ore;
	
    public static Block mithwood_log;
    public static Block mithwood_leaves;
    public static Block mithwood_plank;
    public static Block mithwood_fence;
    public static Block mithwood_fencegate;
    public static Block mithwood_stairs;
    public static Block mithwood_slab_single;
    public static Block mithwood_slab_double;
    public static Block mithwood_door;

    public static final BlockMithwoodSapling mithwood_sapling = new BlockMithwoodSapling("mithwood_sapling");

    public static void init() {

		unobtainium_ore = new BlockBasic("unobtainium_ore", 10, 50);
		unobtainium_ore.setCreativeTab(CreativeTabs.BUILDING_BLOCKS);
		unobtainium_ore.setHarvestLevel("pickaxe", 4);
		unobtainium_ore.setLightLevel(0.5f);

		mithwood_log = new BlockMithwoodLog("mithwood_log", 2, 10);
		mithwood_log.setCreativeTab(CreativeTabs.BUILDING_BLOCKS);
		mithwood_leaves = new BlockMithwoodLeaves("mithwood_leaves", 0.2F, 1);
		mithwood_leaves.setCreativeTab(CreativeTabs.DECORATIONS);
		mithwood_sapling.setCreativeTab(CreativeTabs.DECORATIONS);
		mithwood_plank = new BlockMithwoodPlank("mithwood_plank", Material.WOOD, 2, 10);
		mithwood_plank.setCreativeTab(CreativeTabs.BUILDING_BLOCKS);
		mithwood_fence = new BlockMithwoodFence("mithwood_fence", 1.75F, 4.75F);
		mithwood_fence.setCreativeTab(CreativeTabs.DECORATIONS);
    	mithwood_fencegate = new BlockMithwoodFenceGate().setRegistryName("mithwood_fencegate");
		GameRegistry.register(mithwood_fencegate);
		GameRegistry.register(new ItemBlock(mithwood_fencegate), mithwood_fencegate.getRegistryName());
	    Block woodbase = new BlockPlanks();
	    mithwood_stairs = new BlockMithwoodStairs(woodbase.getDefaultState().withProperty(BlockPlanks.VARIANT, BlockPlanks.EnumType.BIRCH)).setHardness(2.0F).setResistance(10.0F).setUnlocalizedName("mithwood_stairs");
		GameRegistry.registerBlock(mithwood_stairs, "mithwood_stairs");
	    mithwood_slab_single = (BlockSlab)new BlockMithwoodSlabHalf().setHardness(1.75F).setUnlocalizedName("mithwood_slab_single");
	    mithwood_slab_double = (BlockSlab)new BlockMithwoodSlabDouble().setHardness(1.75F).setUnlocalizedName("mithwood_slab_double");
	    GameRegistry.registerBlock(mithwood_slab_single, ItemMithwoodSlab.class, mithwood_slab_single.getUnlocalizedName().substring(5));
	    GameRegistry.registerBlock(mithwood_slab_double, ItemMithwoodSlab.class, mithwood_slab_double.getUnlocalizedName().substring(5));
	    mithwood_door = registerDoor( new BlockMithwoodDoor(), "mithwood_door", ItemsCreate.mithwood_door);

	}
    
    public static Block registerDoor(BlockMithwoodDoor door_block, String name, Item door_item) {
        Block block = registerDoorBlock( door_block, name + "_block");
        door_item = registerDoorItem( new ItemDoor(block), name);
        door_block.setDoorItem(door_item);
        return block;
    }
    
    public static Block registerDoorBlock(Block block, String blockName) {
    	block.setUnlocalizedName(blockName);
		ResourceLocation location = new ResourceLocation("mithwoodforest", blockName);
		GameRegistry.register(block, location);
        MithwoodForest.proxy.registerBlockSided(block);
        Item item = Item.getItemFromBlock(block);
        MithwoodForest.proxy.registerItemVariantModel(item, blockName, 0);
        return block;
    }
    
    public static Item registerDoorItem(Item item, String name) {    
        item.setUnlocalizedName(name);
        item.setCreativeTab(CreativeTabs.REDSTONE);
        GameRegistry.register(item, new ResourceLocation("mithwoodforest", name));
        MithwoodForest.proxy.registerItemSided(item);
        return item;   
    }
    
}
