package rainbeau.mithwoodforest.RMFBlocks;

import net.minecraft.block.Block;
import net.minecraft.block.BlockFenceGate;
import net.minecraft.block.BlockLeaves;
import net.minecraft.block.BlockSapling;
import net.minecraft.client.renderer.block.model.ModelBakery;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.renderer.block.statemap.StateMap;
import net.minecraft.item.Item;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.client.model.ModelLoader;

public class BlocksModels {

	public static void init() {

		registerModels(BlocksCreate.unobtainium_ore);

		registerModels(BlocksCreate.mithwood_log);
		ModelLoader.setCustomStateMapper(BlocksCreate.mithwood_log, new StateMap.Builder().ignore(BlockMithwoodLog.VARIANT).build());
		registerModels(BlocksCreate.mithwood_leaves);
		ModelLoader.setCustomStateMapper(BlocksCreate.mithwood_leaves, new StateMap.Builder().ignore(BlockLeaves.DECAYABLE, BlockLeaves.CHECK_DECAY).build());
		registerModels(BlocksCreate.mithwood_sapling);
		ModelLoader.setCustomStateMapper(BlocksCreate.mithwood_sapling, new StateMap.Builder().ignore(BlockSapling.TYPE, BlockSapling.STAGE).build());
		registerModels(BlocksCreate.mithwood_plank);
		registerModels(BlocksCreate.mithwood_fence);
		registerItemBlock(BlocksCreate.mithwood_fencegate, 0, "mithwood_fencegate");
		ModelLoader.setCustomStateMapper(BlocksCreate.mithwood_fencegate, new StateMap.Builder().ignore(BlockFenceGate.POWERED).build());
	    registerItemBlock(BlocksCreate.mithwood_stairs, 0, "mithwood_stairs");
	    registerItemBlock(BlocksCreate.mithwood_slab_double, 0, "mithwood_slab");
	    registerItemBlock(BlocksCreate.mithwood_slab_single, 0, "mithwood_slab");
	    ModelBakery.registerItemVariants(Item.getItemFromBlock(BlocksCreate.mithwood_slab_double), new ResourceLocation[] { new ResourceLocation("mithwoodforest:mithwood_slab") });
	    ModelBakery.registerItemVariants(Item.getItemFromBlock(BlocksCreate.mithwood_slab_single), new ResourceLocation[] { new ResourceLocation("mithwoodforest:mithwood_slab") });

	}
	
	public static void registerModels(Block block) {
	    ModelLoader.setCustomModelResourceLocation(Item.getItemFromBlock(block), 0, new ModelResourceLocation("mithwoodforest:" + block.getUnlocalizedName().substring(5)));
		ModelResourceLocation modelLocation = new ModelResourceLocation(Item.getItemFromBlock(block).getRegistryName(), "inventory");
	}

	public static void registerItemBlock(Block block, int metadata, String blockName) {
	    ModelLoader.setCustomModelResourceLocation(Item.getItemFromBlock(block), metadata, new ModelResourceLocation("mithwoodforest:" + blockName));
		ModelResourceLocation modelLocation = new ModelResourceLocation(Item.getItemFromBlock(block).getRegistryName(), "inventory");
	}
	
}
