package rainbeau.mithwoodforest.RMFConfig;

import net.minecraftforge.common.config.Property;
import rainbeau.mithwoodforest.MithwoodForest;

public class Config {
	
	public static boolean GrowMithwoodForest;
	public static int MFBiomeID;
	public static int MFBiomeWeight;

	public static int AddGuardians;
	public static int AddBigCats;

	public static boolean EmeraldArmor;
	public static boolean LapisArmor;
	public static boolean MithrilArmor;
	public static boolean ObsidianArmor;
	public static boolean PrismarineArmor;
	public static boolean ArmorToIngots;
	public static boolean ChainRecipes;
	public static boolean Paxels;
	
	public static void init() {

//
// Category Setup
//
		
		String biometab = "general" + "." + "Mithwood Forest Biome Options";
		String mobstab = "general" + "." + "New Mob Options";
		String newarmortab = "general" + "." + "New Armor and Tool Sets";

		MithwoodForest.configFile.addCustomCategoryComment(biometab, "Options for setting up the Mithwood Forest biome.");
		MithwoodForest.configFile.addCustomCategoryComment(mobstab, "Options adding new mobs.");
		MithwoodForest.configFile.addCustomCategoryComment(newarmortab, "New sets of armor and tools, obviously.");

//
// Mithwood Forest Biome Options
//

	    Property prop = MithwoodForest.configFile.get(biometab, "Add Mithwood Forest", true, "Mithwood forests are magical woods growing over large concentrations of mithril.");
	    prop.setRequiresWorldRestart(true);
	    GrowMithwoodForest = prop.getBoolean(true);
	    
	    prop = MithwoodForest.configFile.get(biometab, "Mithwood Forest Biome ID", 126, "Biome ID for mithwood forests.", 1, 256);
	    prop.setRequiresWorldRestart(true);
	    MFBiomeID = prop.getInt(126);

	    prop = MithwoodForest.configFile.get(biometab, "Mithwood Forest Weight", 5, "Biome weight for mithwood forests.", 1, 100);
	    prop.setRequiresWorldRestart(true);
	    MFBiomeWeight = prop.getInt(5);

//
// New Mob Options
//
	
	    prop = MithwoodForest.configFile.get(mobstab, "Add Mithwood Guardians", 25, "Allow mithwood guardians to patrol and defend mithwood forests.", 0, 100);
	    prop.setRequiresWorldRestart(true);
	    AddGuardians = prop.getInt(25);

	    prop = MithwoodForest.configFile.get(mobstab, "Also Add Big Cats", 20, "Add a variety of big cats (leopards, lions, panthers, snow leopards and tigers) to the game.", 0, 100);
	    prop.setRequiresWorldRestart(true);
	    AddBigCats = prop.getInt(20);

//
// New Armor and Tool Sets
//
		
	    prop = MithwoodForest.configFile.get(newarmortab, "Emerald Armor and Tools", true, "Emerald tools and armor are slightly better than those made from diamond.");
	    prop.setRequiresWorldRestart(true);
	    EmeraldArmor = prop.getBoolean(true);

	    prop = MithwoodForest.configFile.get(newarmortab, "Lapis Armor and Tools", true, "Lapis items are slightly better than their iron counterparts, and are exceptionally enchantable.");
	    prop.setRequiresWorldRestart(true);
	    LapisArmor = prop.getBoolean(true);

	    prop = MithwoodForest.configFile.get(newarmortab, "Mithril Armor and Tools", true, "Mithril armor and tools are the best available, and are imbued with magic, as well.");
	    prop.setRequiresWorldRestart(true);
	    MithrilArmor = prop.getBoolean(true);

	    prop = MithwoodForest.configFile.get(newarmortab, "Obsidian Armor and Tools", true, "Obsidian armor is fragile, but nearly as good as diamond, and imbues you with fire resistance.");
	    prop.setRequiresWorldRestart(true);
	    ObsidianArmor = prop.getBoolean(true);

	    prop = MithwoodForest.configFile.get(newarmortab, "Prismarine Armor and Tools", true, "Prismarine tools and armor are comparable to those of emerald, and the armor is magical.");
	    prop.setRequiresWorldRestart(true);
	    PrismarineArmor = prop.getBoolean(true);
	    
	    prop = MithwoodForest.configFile.get(newarmortab, "Recipe - Armor to Ingots", true, "Armor pieces may be smelted back to raw materials.");
	    prop.setRequiresWorldRestart(true);
	    ArmorToIngots = prop.getBoolean(true);

	    prop = MithwoodForest.configFile.get(newarmortab, "Recipe - Chainmail Armor", true, "You can craft chainmail armor items using iron ingots and leather.");
	    prop.setRequiresWorldRestart(true);
	    ChainRecipes = prop.getBoolean(true);
	    
	    prop = MithwoodForest.configFile.get(newarmortab, "Tools - Paxels", true, "Paxels are multi-function tools, simultaneously filling the roles of axes, hoes, pickaxes and shovels.");
	    prop.setRequiresWorldRestart(true);
	    Paxels = prop.getBoolean(true);

//
// Save Changes
//
	    
	    if (MithwoodForest.configFile.hasChanged()) {
			MithwoodForest.configFile.save();
		}

	}

}
