package rainbeau.mithwoodforest.RMFEntities;

import javax.annotation.Nullable;

import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityAgeable;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.IEntityLivingData;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.EntityAIAttackMelee;
import net.minecraft.entity.ai.EntityAIAvoidEntity;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAILeapAtTarget;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAIWatchClosest;
import net.minecraft.entity.monster.EntityPigZombie;
import net.minecraft.entity.monster.EntitySkeleton;
import net.minecraft.entity.monster.EntitySpider;
import net.minecraft.entity.monster.EntityWitch;
import net.minecraft.entity.monster.EntityZombie;
import net.minecraft.entity.monster.IMob;
import net.minecraft.entity.passive.EntityAnimal;
import net.minecraft.entity.passive.EntityChicken;
import net.minecraft.entity.passive.EntityCow;
import net.minecraft.entity.passive.EntityPig;
import net.minecraft.entity.passive.EntityRabbit;
import net.minecraft.entity.passive.EntitySheep;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.entity.passive.EntityWolf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.init.MobEffects;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.potion.PotionEffect;
import net.minecraft.util.DamageSource;
import net.minecraft.util.EnumHand;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.SoundEvent;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.DifficultyInstance;
import net.minecraft.world.EnumDifficulty;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import rainbeau.mithwoodforest.RMFConfig.Config;

public class BigCatEntity extends EntityAnimal implements IMob {

	protected float prevHeadAngle;
	protected float targetHeadAngle;
	protected boolean isShaking;
	protected boolean startedShaking;
	protected float timeBigCatIsShaking;
	protected float prevTimeBigCatIsShaking;
	private boolean isManEater = false;
	private boolean isSkittish = false;
	public static SoundEvent bigcat_death;
	public static SoundEvent bigcat_growl1;
	public static SoundEvent bigcat_growl2;
	public static SoundEvent bigcat_growl3;
	public static SoundEvent bigcat_growl4;
	public static SoundEvent bigcat_growl5;
	public static SoundEvent bigcat_growl6;
	public static SoundEvent bigcat_hurt;
	public static SoundEvent bigcat_shake;
   	protected EntityAIBase aiAvoidPlayer = new EntityAIAvoidEntity(this, EntityPlayer.class, 6.0F, 1.0D, 1.2D); 
   	protected EntityAIBase aiAvoidVillager = new EntityAIAvoidEntity(this, EntityVillager.class, 6.0F, 1.0D, 1.2D);    
	protected EntityAIBase aiAvoidPigZombie = new EntityAIAvoidEntity(this, EntityPigZombie.class, 6.0F, 1.0D, 1.2D);    
	protected EntityAIBase aiAvoidSkeleton = new EntityAIAvoidEntity(this, EntitySkeleton.class, 6.0F, 1.0D, 1.2D);    
	protected EntityAIBase aiAvoidWitch = new EntityAIAvoidEntity(this, EntityWitch.class, 6.0F, 1.0D, 1.2D);    
	protected EntityAIBase aiAvoidZombie = new EntityAIAvoidEntity(this, EntityZombie.class, 6.0F, 1.0D, 1.2D);    
	protected EntityAIBase aiAvoidGuardian = new EntityAIAvoidEntity(this, GuardianEntity.class, 6.0F, 1.0D, 1.2D); 
	protected EntityAIBase aiAttackPlayer = new EntityAINearestAttackableTarget(this, EntityPlayer.class, true);
	protected EntityAIBase aiAttackVillager = new EntityAINearestAttackableTarget(this, EntityVillager.class, true);
	protected EntityAIBase aiAttackPigZombie = new EntityAINearestAttackableTarget(this, EntityPigZombie.class, true);
	protected EntityAIBase aiAttackSkeleton = new EntityAINearestAttackableTarget(this, EntitySkeleton.class, true);
	protected EntityAIBase aiAttackWitch = new EntityAINearestAttackableTarget(this, EntityWitch.class, true);
	protected EntityAIBase aiAttackZombie = new EntityAINearestAttackableTarget(this, EntityZombie.class, true);
	protected EntityAIBase aiAttackGuardian = new EntityAINearestAttackableTarget(this, GuardianEntity.class, true);
	
	static {
		bigcat_death = new SoundEvent(new ResourceLocation("mithwoodforest", "bigcat_death"));
		bigcat_death.setRegistryName("bigcat_death");
		GameRegistry.register(BigCatEntity.bigcat_death);
		bigcat_growl1 = new SoundEvent(new ResourceLocation("mithwoodforest", "bigcat_growl1"));
		bigcat_growl1.setRegistryName("bigcat_growl1");
		GameRegistry.register(BigCatEntity.bigcat_growl1);
		bigcat_growl2 = new SoundEvent(new ResourceLocation("mithwoodforest", "bigcat_growl2"));
		bigcat_growl2.setRegistryName("bigcat_growl2");
		GameRegistry.register(BigCatEntity.bigcat_growl2);
		bigcat_growl3 = new SoundEvent(new ResourceLocation("mithwoodforest", "bigcat_growl3"));
		bigcat_growl3.setRegistryName("bigcat_growl3");
		GameRegistry.register(BigCatEntity.bigcat_growl3);
		bigcat_growl4 = new SoundEvent(new ResourceLocation("mithwoodforest", "bigcat_growl4"));
		bigcat_growl4.setRegistryName("bigcat_growl4");
		GameRegistry.register(BigCatEntity.bigcat_growl4);
		bigcat_growl5 = new SoundEvent(new ResourceLocation("mithwoodforest", "bigcat_growl5"));
		bigcat_growl5.setRegistryName("bigcat_growl5");
		GameRegistry.register(BigCatEntity.bigcat_growl5);
		bigcat_growl6 = new SoundEvent(new ResourceLocation("mithwoodforest", "bigcat_growl6"));
		bigcat_growl6.setRegistryName("bigcat_growl6");
		GameRegistry.register(BigCatEntity.bigcat_growl6);
		bigcat_hurt = new SoundEvent(new ResourceLocation("mithwoodforest", "bigcat_hurt"));
		bigcat_hurt.setRegistryName("bigcat_hurt");
		GameRegistry.register(BigCatEntity.bigcat_hurt);
		bigcat_shake = new SoundEvent(new ResourceLocation("mithwoodforest", "bigcat_shake"));
		bigcat_shake.setRegistryName("bigcat_shake");
		GameRegistry.register(BigCatEntity.bigcat_shake);
	}

	public BigCatEntity(World world) {
		super(world);
	    setSize(1.0F, 1.33F);
		this.tasks.addTask(0, new EntityAISwimming(this));
		this.tasks.addTask(1, new EntityAILeapAtTarget(this, 0.5F));
		this.tasks.addTask(2, new EntityAIAttackMelee(this, 1.0D, true));
		this.tasks.addTask(3, new EntityAIWander(this, 1.0D));
		this.tasks.addTask(4, new EntityAIWatchClosest(this, EntityPlayer.class, 8.0F));
		this.tasks.addTask(5, new EntityAILookIdle(this));
		this.targetTasks.addTask(1, new EntityAIHurtByTarget(this, false, new Class[0]));
		this.targetTasks.addTask(3, new EntityAINearestAttackableTarget(this, EntityChicken.class, true));
		this.targetTasks.addTask(3, new EntityAINearestAttackableTarget(this, EntityCow.class, true));
		this.targetTasks.addTask(3, new EntityAINearestAttackableTarget(this, EntityPig.class, true));
		this.targetTasks.addTask(3, new EntityAINearestAttackableTarget(this, EntityRabbit.class, true));
		this.targetTasks.addTask(3, new EntityAINearestAttackableTarget(this, EntitySheep.class, true));
		this.targetTasks.addTask(4, new EntityAINearestAttackableTarget(this, EntitySpider.class, true));
	}
  
    @Override
    @Nullable
    public IEntityLivingData onInitialSpawn(DifficultyInstance difficulty, @Nullable IEntityLivingData livingdata) {
        livingdata = super.onInitialSpawn(difficulty, livingdata);
        int skittishLevel = rand.nextInt(3);
        if (skittishLevel == 0) {
            this.isManEater = true; setManEater();
        }
        else if (skittishLevel == 2) {
            this.isSkittish = true; setSkittish();
        }
        return livingdata;
    }

    protected void setManEater() {
    	this.targetTasks.addTask(2, aiAttackPlayer);
    	this.targetTasks.addTask(3, aiAttackVillager);
    	this.targetTasks.addTask(4, aiAttackPigZombie);
    	this.targetTasks.addTask(4, aiAttackSkeleton);
    	this.targetTasks.addTask(4, aiAttackWitch);
    	this.targetTasks.addTask(4, aiAttackZombie);
    	this.targetTasks.addTask(4, aiAttackGuardian);
    }

    protected void removeManEater() {
    	this.targetTasks.removeTask(aiAttackPlayer);
    	this.targetTasks.removeTask(aiAttackVillager);
    	this.targetTasks.removeTask(aiAttackPigZombie);
    	this.targetTasks.removeTask(aiAttackSkeleton);
    	this.targetTasks.removeTask(aiAttackWitch);
    	this.targetTasks.removeTask(aiAttackZombie);
    	this.targetTasks.removeTask(aiAttackGuardian);
    }

    protected void setSkittish() {
    	this.tasks.addTask(3, aiAvoidPlayer);
    	this.tasks.addTask(3, aiAvoidVillager);    
    	this.tasks.addTask(3, aiAvoidPigZombie);
    	this.tasks.addTask(3, aiAvoidSkeleton);
    	this.tasks.addTask(3, aiAvoidWitch);    
    	this.tasks.addTask(3, aiAvoidZombie);    
    	this.tasks.addTask(3, aiAvoidGuardian); 
    }
  
    protected void removeSkittish() {
    	this.tasks.removeTask(aiAvoidPlayer);
    	this.tasks.removeTask(aiAvoidVillager);    
    	this.tasks.removeTask(aiAvoidPigZombie); 
    	this.tasks.removeTask(aiAvoidSkeleton);
    	this.tasks.removeTask(aiAvoidWitch);    
    	this.tasks.removeTask(aiAvoidZombie);    
    	this.tasks.removeTask(aiAvoidGuardian); 
    }
    
	@Override
	public EntityAgeable createChild(EntityAgeable ageable) {
		return null;
	}
  
	@Override
	public boolean getCanSpawnHere() {
		if (Config.AddBigCats < 1) { return false; }
    	BlockPos blockpos = new BlockPos(this.posX, this.getEntityBoundingBox().minY, this.posZ);
        if (blockpos.getY() < this.worldObj.getSeaLevel()-5) {
            return false;
        }
       	int light = this.worldObj.getLightFromNeighbors(blockpos);
       	if (light < 6) {
       		return false;
       	}
       	if (this.worldObj.getDifficulty() == EnumDifficulty.PEACEFUL) {
       		return false;
       	}
       	IBlockState iblockstate = this.worldObj.getBlockState((new BlockPos(this)).down());
       	return iblockstate.func_189884_a(this);
	}
  
	@Override
	protected boolean canDespawn() {
		return true;
	}

	@Override
	public void setAttackTarget(@Nullable EntityLivingBase entitylivingbaseIn) {
		super.setAttackTarget(entitylivingbaseIn);
	}
  
	@Override
	protected SoundEvent getAmbientSound() {
		int sound = rand.nextInt(6);
		if (sound == 0) { return bigcat_growl1; } 
		else if (sound == 1) { return bigcat_growl2; }
		else if (sound == 2) { return bigcat_growl3; }
		else if (sound == 3) { return bigcat_growl4; }
		else if (sound == 4) { return bigcat_growl5; }
		else { return bigcat_growl6; }
	}

	@Override
	protected SoundEvent getHurtSound() {
		return bigcat_hurt;
	}

	@Override
	protected SoundEvent getDeathSound() {
		return bigcat_death;
	}
	
	@Override
	protected float getSoundVolume() {
		return 0.4F;
	}
  
	@Override
	protected Item getDropItem() {
		return Items.LEATHER;
	}
  
	@Override
	protected void dropFewItems(boolean flag, int add) {
		int count = this.rand.nextInt(3) + this.rand.nextInt(1 + add);
		dropItem(Items.LEATHER, count);
		count = this.rand.nextInt(3) + 1 + this.rand.nextInt(1 + add);
		if (isBurning()) {
			dropItem(Items.COOKED_BEEF, count);
		} 
		else {
			dropItem(Items.BEEF, count);
		}
	}
  
	@Override
	protected int getExperiencePoints(EntityPlayer par1EntityPlayer) {
		return 1 + this.worldObj.rand.nextInt(4);
	}
  
	@Override
	public boolean processInteract(EntityPlayer entityplayer, EnumHand enumHand, ItemStack itemStack) {
		return false;
	}
  
	@Override
	public boolean attackEntityAsMob(Entity entity) {
		return entity.attackEntityFrom(DamageSource.causeMobDamage(this), 4.0F);
	}

	@Override
	public float getEyeHeight() {
		return this.height * 0.8F;
	}

	@SideOnly(Side.CLIENT)	
	public float getInterestedAngle(float parRateOfAngleChange) {	
		return (this.prevHeadAngle + (this.targetHeadAngle - this.prevHeadAngle) * parRateOfAngleChange) * 0.15F * 3.1415927F;
	}
	
	@Override
	public void onLivingUpdate() {
		super.onLivingUpdate();
		if ((!this.worldObj.isRemote) && (this.isShaking) && (!this.startedShaking) && (!hasPath()) && (this.onGround)) {
			this.startedShaking = true;
			this.timeBigCatIsShaking = 0.0F;
			this.prevTimeBigCatIsShaking = 0.0F;
			this.worldObj.setEntityState(this, (byte)8);
		}
		if (this.getHealth() < (this.getMaxHealth()/6)) {
			if (this.isSkittish && (!this.isPotionActive(MobEffects.REGENERATION))) {
				this.addPotionEffect(new PotionEffect(MobEffects.REGENERATION, 1800, 0, true, false));
			}
			else if (!this.isSkittish && (rand.nextInt(20) == 0)) {
				this.isManEater = false; removeManEater();
				this.isSkittish = true; setSkittish();
			}
		}
		else if (this.getHealth() < (this.getMaxHealth()/3)) {
			if (!this.isSkittish && (rand.nextInt(200) == 0)) {
				this.isManEater = false; removeManEater();
				this.isSkittish = true; setSkittish();
			}
		}
		else if (this.getHealth() < (this.getMaxHealth())) {
			if (!this.isSkittish && (rand.nextInt(2000) == 0)) {
				this.isManEater = false; removeManEater();
				this.isSkittish = true; setSkittish();
			}
		}
		else {
			if (this.isSkittish) {
				if ((this.getHealth() < this.getMaxHealth()) && (!this.isPotionActive(MobEffects.REGENERATION))) {
					if (rand.nextInt(200) == 0) {
						this.addPotionEffect(new PotionEffect(MobEffects.REGENERATION, 1800, 0, true, false));
					}
				}
				else if (rand.nextInt(20000) == 0) {
					this.isSkittish = false; removeSkittish();
					if (rand.nextInt(3) == 0) {
						this.isManEater = true; setManEater();				
					}
				}				
			}
			else if (this.isManEater) {
				if (rand.nextInt(20000) == 0) {
					this.isManEater = false; removeManEater();
					if (rand.nextInt(3) == 0) {
						this.isSkittish = true; setSkittish();				
					}
				}
			}
			else {
				if (rand.nextInt(20000) == 0) {
					if (rand.nextInt(2) == 0) {
						this.isManEater = true; setManEater();
					}
					else {
						this.isSkittish = true; setSkittish();
					}
				}
			}
		}
	}
	
	@Override
	public void onUpdate() {
		super.onUpdate();
		this.prevHeadAngle = this.targetHeadAngle;
		this.targetHeadAngle += (0.0F - this.targetHeadAngle) * 0.4F;
	    if (isWet()) {
	    	this.isShaking = true;
	    	this.startedShaking = false;
	    	this.timeBigCatIsShaking = 0.0F;
	    	this.prevTimeBigCatIsShaking = 0.0F;
	    }
	   	else if (((this.isShaking) || (this.startedShaking)) && (this.startedShaking)) {
	   		if (this.timeBigCatIsShaking == 0.0F) {
                this.playSound(bigcat_shake, this.getSoundVolume(), (this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F);
	   		}
	   		this.prevTimeBigCatIsShaking = this.timeBigCatIsShaking;
	   		this.timeBigCatIsShaking += 0.05F;
	   		if (this.prevTimeBigCatIsShaking >= 2.0F) {
	   			this.isShaking = false;
	   			this.startedShaking = false;
	   			this.prevTimeBigCatIsShaking = 0.0F;
	   			this.timeBigCatIsShaking = 0.0F;
	   		}	
	   		if (this.timeBigCatIsShaking > 0.4F) {
                float f = (float)this.getEntityBoundingBox().minY;
                int i = (int)(MathHelper.sin((this.timeBigCatIsShaking - 0.4F) * (float)Math.PI) * 7.0F);
                for (int j = 0; j < i; ++j) {
                    float f1 = (this.rand.nextFloat() * 2.0F - 1.0F) * this.width * 0.5F;
                    float f2 = (this.rand.nextFloat() * 2.0F - 1.0F) * this.width * 0.5F;
                    this.worldObj.spawnParticle(EnumParticleTypes.WATER_SPLASH, this.posX + (double)f1, (double)(f + 0.8F), this.posZ + (double)f2, this.motionX, this.motionY, this.motionZ, new int[0]);
                }
	   		}
	   	}
	}
	
	@SideOnly(Side.CLIENT)
	public boolean getBigCatShaking() {
		return this.isShaking;
	}
	  
	@SideOnly(Side.CLIENT)
	public float getShadingWhileShaking(float parShakeRate) {
		return 0.75F + (this.prevTimeBigCatIsShaking + (this.timeBigCatIsShaking - this.prevTimeBigCatIsShaking) * parShakeRate) / 2.0F * 0.25F;
	}
	  
	@SideOnly(Side.CLIENT)
	public float getShakeAngle(float parShakeRate, float par2) {
		float f2 = (this.prevTimeBigCatIsShaking + (this.timeBigCatIsShaking - this.prevTimeBigCatIsShaking) * parShakeRate + par2) / 1.8F;
		if (f2 < 0.0F) {
			f2 = 0.0F;
		} 
		else if (f2 > 1.0F) {
			f2 = 1.0F;
		}
		return MathHelper.sin(f2 * 3.1415927F) * MathHelper.sin(f2 * 3.1415927F * 11.0F) * 0.15F * 3.1415927F;
	}
	
	@Override
	@SideOnly(Side.CLIENT)
	public void handleStatusUpdate(byte par1) {
		if (par1 == 8) {
			this.startedShaking = true;
			this.timeBigCatIsShaking = 0.0F;
			this.prevTimeBigCatIsShaking = 0.0F;
		}
		else {
			super.handleStatusUpdate(par1);
		}
	}

    @Override
    public void writeEntityToNBT(NBTTagCompound root) {
    	super.writeEntityToNBT(root);
    	root.setBoolean("isManEater", this.isManEater);
    	root.setBoolean("isSkittish", this.isSkittish);
    }
    
    @Override
    public void readEntityFromNBT(NBTTagCompound root) {
    	super.readEntityFromNBT(root);
    	isManEater = root.getBoolean("isManEater");
    	isSkittish = root.getBoolean("isSkittish");
    	if (isManEater) {
    		setManEater();
    	}
    	else if (isSkittish) {
    		setSkittish();
    	}
    }

    @SideOnly(Side.CLIENT)
    public float getTailRotation() {
        if (this.isManEater) { return 1.5f; }
        else if (this.isSkittish) { return 0.5f; }
        else { return 1.0f; }
    }
    
}
