package rainbeau.mithwoodforest.RMFEntities;

import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;

public class BigCatModel extends ModelBase {

	protected double distanceMovedTotal = 0.0D;
	protected static final double CYCLES_PER_BLOCK = 3.0D;
	protected int cycleIndex = 0;
	ModelRenderer head;
	ModelRenderer body;
	ModelRenderer leg1;
	ModelRenderer leg2;
	ModelRenderer leg3;
	ModelRenderer leg4;
	ModelRenderer tail;

	public BigCatModel() {
		this.textureWidth = 64;
		this.textureHeight = 32;
	    this.head = new ModelRenderer(this, 24, 0);
	    this.head.addBox(-3.0F, -3.0F, -2.0F, 6, 5, 4);
	    this.head.setRotationPoint(-1.0F, 15.5F, -7.0F);
	    this.head.setTextureSize(64, 32);
	    this.head.mirror = true;
	    this.head.setTextureOffset(18, 14).addBox(-3.0F, -4.0F, -2.0F, 1, 1, 1, 0.0F);
	    this.head.setTextureOffset(18, 18).addBox(2.0F, -4.0F, -2.0F, 1, 1, 1, 0.0F);
	    this.head.setTextureOffset(0, 28).addBox(-1.5F, -1.0F, -3.0F, 3, 3, 1, 0.0F);
	    this.body = new ModelRenderer(this, 23, 11);
	    this.body.addBox(-3.0F, -7.0F, -3.0F, 4, 14, 6);
	    this.body.setRotationPoint(0.0F, 15.5F, 0.0F);
	    this.body.setTextureSize(64, 32);
	    this.body.mirror = true;
	    this.leg1 = new ModelRenderer(this, 55, 12);
	    this.leg1.addBox(-1.0F, 0.0F, -1.0F, 2, 7, 2);
	    this.leg1.setRotationPoint(-2.5F, 17.0F, 5.0F);
	    this.leg1.setTextureSize(64, 32);
	    this.leg1.mirror = true;
	    this.leg2 = new ModelRenderer(this, 55, 22);
	    this.leg2.addBox(-1.0F, 0.0F, -1.0F, 2, 7, 2);
	    this.leg2.setRotationPoint(0.5F, 17.0F, 5.0F);
	    this.leg2.setTextureSize(64, 32);
	    this.leg2.mirror = true;
	    this.leg3 = new ModelRenderer(this, 45, 12);
	    this.leg3.addBox(-1.0F, 0.0F, -1.0F, 2, 7, 2);
	    this.leg3.setRotationPoint(-2.5F, 17.0F, -6.0F);
	    this.leg3.setTextureSize(64, 32);
	    this.leg3.mirror = true;
	    this.leg4 = new ModelRenderer(this, 45, 22);
	    this.leg4.addBox(-1.0F, 0.0F, -1.0F, 2, 7, 2);
	    this.leg4.setRotationPoint(0.5F, 17.0F, -6.0F);
	    this.leg4.setTextureSize(64, 32);
	    this.leg4.mirror = true;
	    this.tail = new ModelRenderer(this, 9, 13);
	    this.tail.addBox(-1.0F, 0.0F, -1.0F, 2, 11, 2);
	    this.tail.setRotationPoint(-1.0F, 13.0F, 6.0F);
	    this.tail.setTextureSize(64, 32);
	    this.tail.mirror = true;
	}
	
	protected void updateDistanceMovedTotal(Entity parEntity) {
		this.distanceMovedTotal += parEntity.getDistance(parEntity.prevPosX, parEntity.prevPosY, parEntity.prevPosZ);
	}
  
	protected double getDistanceMovedTotal(Entity parEntity) {
		return this.distanceMovedTotal;
	}
  
	protected float degToRad(float degrees) {
		return degrees * 3.1415927F / 180.0F;
	}
  
	protected void setRotation(ModelRenderer model, float rotX, float rotY, float rotZ) {
		model.rotateAngleX = degToRad(rotX);
		model.rotateAngleY = degToRad(rotY);
		model.rotateAngleZ = degToRad(rotZ);
	}
  
	protected void spinX(ModelRenderer model) {
		model.rotateAngleX += degToRad(0.5F);
	}
  
	protected void spinY(ModelRenderer model) {
		model.rotateAngleY += degToRad(0.5F);
	}
  
	protected void spinZ(ModelRenderer model) {
		model.rotateAngleZ += degToRad(0.5F);
	}
  
	protected void convertToChildOf(ModelRenderer parChild, ModelRenderer parParent) {
		parChild.rotationPointX -= parParent.rotationPointX;
		parChild.rotationPointY -= parParent.rotationPointY;
		parChild.rotationPointZ -= parParent.rotationPointZ;
		parChild.rotateAngleX -= parParent.rotateAngleX;
		parChild.rotateAngleY -= parParent.rotateAngleY;
		parChild.rotateAngleZ -= parParent.rotateAngleZ;
		parParent.addChild(parChild);
	}
	    
	@Override
	public void setRotationAngles(float par1, float par2, float par3, float par4, float par5, float par6, Entity par7Entity) {
		super.setRotationAngles(par1, par2, par3, par4, par5, par6, par7Entity);
		this.head.rotateAngleX = (par5 / 57.295776F);
		this.head.rotateAngleY = (par4 / 57.295776F);
		this.tail.rotateAngleX = par3;
	}
	
}
