package rainbeau.mithwoodforest.RMFEntities;

import java.util.LinkedList;

import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.init.Biomes;
import net.minecraft.world.biome.Biome;
import net.minecraftforge.common.BiomeDictionary;
import net.minecraftforge.fml.common.registry.EntityRegistry;
import rainbeau.mithwoodforest.RMFConfig.Config;
import rainbeau.mithwoodforest.RMFWorldGen.BiomesRMF;

public class EntitiesBiomes {

	public static void init() {
        int AddBigCats = Config.AddBigCats;
        if (AddBigCats > 100) { AddBigCats = 100; }
        int AddGuardians = Config.AddGuardians;
        if (AddGuardians > 100) {AddGuardians = 100; }
		BiomeDictionary.registerAllBiomesAndGenerateEvents();
        Biome[] leopardBiomes = getBiomes("leopard", new BiomeDictionary.Type[] { BiomeDictionary.Type.DENSE });
        Biome[] snowleopardBiomes = getBiomes("snowleopard", new BiomeDictionary.Type[] { BiomeDictionary.Type.MOUNTAIN });
        Biome[] lionBiomes = getBiomes("lion", new BiomeDictionary.Type[] { BiomeDictionary.Type.PLAINS, BiomeDictionary.Type.SANDY });
        Biome[] pantherBiomes = getBiomes("panther", new BiomeDictionary.Type[] { BiomeDictionary.Type.FOREST, BiomeDictionary.Type.SWAMP });
        Biome[] tigerBiomes = getBiomes("tiger", new BiomeDictionary.Type[] { BiomeDictionary.Type.FOREST, BiomeDictionary.Type.SWAMP });
		if (Config.GrowMithwoodForest == true) {
			Biome[] mithwoodBiome = { BiomesRMF.mithwoodForest };
			if (AddBigCats > 0) {
				addSpawn(MithwoodTigerEntity.class, 1, 1, 2, mithwoodBiome);
			}
			if (AddGuardians > 0) {
	        	addSpawn(GuardianEntity.class, 8, 2, 4, mithwoodBiome);
	        }
		}
        if (AddBigCats > 0) {
        	addSpawn(LeopardEntity.class, 4, 1, 2, leopardBiomes);
        	addSpawn(LionEntity.class, 4, 1, 2, lionBiomes);
        	addSpawn(PantherEntity.class, 4, 1, 2, pantherBiomes);
        	addSpawn(SnowLeopardEntity.class, 4, 1, 2, snowleopardBiomes);
        	addSpawn(TigerEntity.class, 4, 1, 2, tigerBiomes);
    	}
	}

    private static Biome[] getBiomes(String catType, BiomeDictionary.Type... types) {
    	LinkedList<Biome> list = new LinkedList();
    	for (BiomeDictionary.Type t : types) {
    		Biome[] biomes = BiomeDictionary.getBiomesForType(t);
    		for (Biome bgb : biomes) {
    			if ((!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.END)) 
   					&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.MAGICAL))
    				&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.NETHER))
					&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.WATER))
    				&& (!bgb.getBiomeName().contains("Void"))) {
           			if (catType == "leopard") {
           				if (!list.contains(bgb)) {
           					list.add(bgb);
           				}
           			}
           			if ((catType == "snowleopard")
               			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.DENSE))) {
               			if (!list.contains(bgb)) {
               				list.add(bgb);
               			}
               		}
           			if ((catType == "lion")
               			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.DENSE)) 
               			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.MOUNTAIN))) {
               			if (!list.contains(bgb)) {
               				list.add(bgb);
               			}
               		}
           			if ((catType == "panther")
               			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.COLD)) 
               			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.DENSE))
               			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.MOUNTAIN))
               			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.PLAINS))
              			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.SANDY))) {
               			if (!list.contains(bgb)) {
               				list.add(bgb);
               			}
               		}
          			if ((catType == "tiger")
            			&& (BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.COLD)) 
               			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.DENSE))
               			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.MOUNTAIN))
               			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.PLAINS))
              			&& (!BiomeDictionary.isBiomeOfType(bgb, BiomeDictionary.Type.SANDY))) {
            			if (!list.contains(bgb)) {
            				list.add(bgb);
            			}
            		}
    			}
    		}
    	}
    	return (Biome[])list.toArray(new Biome[0]);
    }

    private static void addSpawn(Class<? extends EntityLiving> entityClass, int spawnProb, int min, int max, Biome[] biomes) {
    	if (spawnProb > 0) {
    		EntityRegistry.addSpawn(entityClass, spawnProb, min, max, EnumCreatureType.MONSTER, biomes);
    	}
    }

}
