package rainbeau.mithwoodforest.RMFEntities;

import java.util.Map;

import com.google.common.collect.Maps;

import net.minecraft.entity.Entity;
import net.minecraftforge.fml.common.registry.EntityRegistry;
import rainbeau.mithwoodforest.MithwoodForest;

public class EntitiesCreate {
    
    public static final Map<Integer, String> idToRMFEntityName = Maps.<Integer, String>newLinkedHashMap();
    private static int nextRMFEntityId = 1;
    
    public static void init() {
   		registerRMFEntity(LeopardEntity.class, "leopard", 64, 3, true, 0xc0a060, 0x000000);
   		registerRMFEntity(LionEntity.class, "lion", 64, 3, true, 0xc0a060, 0xe0c080);
   		registerRMFEntity(MithwoodTigerEntity.class, "mithwoodtiger", 64, 3, true, 0x40a0e0, 0x000000);
   		registerRMFEntity(PantherEntity.class, "panther", 64, 3, true, 0x000000, 0x403030);
   		registerRMFEntity(SnowLeopardEntity.class, "snowleopard", 64, 3, true, 0xe0d0c0, 0x000000);
   		registerRMFEntity(TigerEntity.class, "tiger", 64, 3, true, 0xd06000, 0x000000);
   		registerRMFEntity(GuardianEntity.class, "guardian", 64, 3, true, 0xffc080, 0xa02000);
    }
    
    public static int registerRMFEntity(Class<? extends Entity> entityClass, String entityName, int trackingRange, int updateFrequency, boolean sendsVelocityUpdates, int bkEggColor, int fgEggColor) {
        int rmfEntityId = nextRMFEntityId;
        nextRMFEntityId++;
        EntityRegistry.registerModEntity(entityClass, entityName, rmfEntityId, MithwoodForest.instance, trackingRange, updateFrequency, sendsVelocityUpdates, bkEggColor, fgEggColor);
        idToRMFEntityName.put(rmfEntityId, entityName);
        return rmfEntityId;
    }
        
}
