package rainbeau.mithwoodforest.RMFEntities;

import org.lwjgl.opengl.GL11;

import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.math.MathHelper;

public class TigerModel extends BigCatModel {

	public TigerModel() {
		super();
	}
	
	@Override
	public void render(Entity parEntity, float parTime, float parSwingSuppress, float par4, float parHeadAngleY, float parHeadAngleX, float par7) {
		renderTiger((TigerEntity)parEntity, parTime, parSwingSuppress, par4, parHeadAngleY, parHeadAngleX, par7);
	}
  
	public void renderTiger(TigerEntity entity, float f, float f1, float f2, float f3, float f4, float f5) {
		super.render(entity, f, f1, f2, f3, f4, f5);
		setRotationAngles(f, f1, f2, f3, f4, f5, entity);
		GL11.glPushMatrix();
		GL11.glTranslatef(0.0F, -0.2F, 0.0F);
		GL11.glScalef(1.2F, 1.2F, 1.2F);
		this.head.renderWithRotation(f5);
		this.body.render(f5);
		this.leg1.render(f5);
		this.leg2.render(f5);
		this.leg3.render(f5);
		this.leg4.render(f5);
		this.tail.renderWithRotation(f5);
		GL11.glPopMatrix();
	}
  
	@Override
	public void setLivingAnimations(EntityLivingBase parEntityLivingBase, float parLimbSwingAngle, float parMaxLimbSwingDistance, float parHeadAngleChangeRate) {
		TigerEntity entityBigCat = (TigerEntity)parEntityLivingBase;
		this.tail.rotateAngleY = (MathHelper.cos(parLimbSwingAngle * 0.6662F) * 1.4F * parMaxLimbSwingDistance);
		this.body.setRotationPoint(0.0F, 14.0F, 2.0F);
		this.body.rotateAngleX = 1.5707964F;
		this.tail.setRotationPoint(-1.0F, 12.0F, 8.0F);
		this.leg1.setRotationPoint(-2.5F, 16.0F, 7.0F);
		this.leg2.setRotationPoint(0.5F, 16.0F, 7.0F);
		this.leg3.setRotationPoint(-2.5F, 16.0F, -4.0F);
		this.leg4.setRotationPoint(0.5F, 16.0F, -4.0F);
		this.leg1.rotateAngleX = (MathHelper.cos(parLimbSwingAngle * 0.6662F) * 1.4F * parMaxLimbSwingDistance);
		this.leg2.rotateAngleX = (MathHelper.cos(parLimbSwingAngle * 0.6662F + 3.1415927F) * 1.4F * parMaxLimbSwingDistance);
		this.leg3.rotateAngleX = (MathHelper.cos(parLimbSwingAngle * 0.6662F + 3.1415927F) * 1.4F * parMaxLimbSwingDistance);
		this.leg4.rotateAngleX = (MathHelper.cos(parLimbSwingAngle * 0.6662F) * 1.4F * parMaxLimbSwingDistance);
		this.head.rotateAngleZ = (entityBigCat.getInterestedAngle(parHeadAngleChangeRate) + entityBigCat.getShakeAngle(parHeadAngleChangeRate, 0.0F));
		this.body.rotateAngleZ = entityBigCat.getShakeAngle(parHeadAngleChangeRate, -0.16F);
		this.tail.rotateAngleZ = entityBigCat.getShakeAngle(parHeadAngleChangeRate, -0.2F);
	}
  	
}
