package rainbeau.mithwoodforest.RMFEvents;

import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.Entity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.biome.Biome;
import net.minecraftforge.client.event.EntityViewRenderEvent.FogDensity;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import rainbeau.mithwoodforest.RMFWorldGen.BiomeMithwoodForest;

public class EventHandlerClient {

	private float fogRender;

	@SubscribeEvent
	public void onFoggyMornings(FogDensity event) {
		Entity entity = event.getEntity();
		World world = entity.worldObj;
		BlockPos pos = entity.getPosition();
		Biome biome = world.getBiomeGenForCoords(pos);
		float f = (float)Math.pow(0.1D, 6);
		boolean flag = false;
		if (biome instanceof BiomeMithwoodForest) {
			long time = world.getWorldTime();
			int depth = 0;
			if (time >= 12000L && time < 13800 || time >= 22200 && time < 1000) {
				depth = 5;
			}
			else if (time >= 13800 && time < 22200) {
				depth = 4;
			}
			if (depth > 0) {
				float density = (float)Math.abs(Math.pow((entity.posY - 63) / (127 - 63), depth));
				if (fogRender < density) {
					fogRender += f;
				}
				else if (fogRender > density) {
					fogRender -= f;
				}
				flag = true;
			}
		}
		if (!flag && fogRender > 0.0F) {
			fogRender -= f;
		}
		if (fogRender > 0.0F) {
			GlStateManager.setFog(GlStateManager.FogMode.EXP);
			event.setDensity(fogRender);
			event.setCanceled(true);
		}
	}
	
}
