package rainbeau.mithwoodforest.RMFEvents;

import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.entity.Entity;
import net.minecraft.entity.ai.EntityAIAvoidEntity;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.monster.EntitySkeleton;
import net.minecraft.entity.monster.EntityZombie;
import net.minecraft.entity.passive.EntityChicken;
import net.minecraft.entity.passive.EntityCow;
import net.minecraft.entity.passive.EntityPig;
import net.minecraft.entity.passive.EntityRabbit;
import net.minecraft.entity.passive.EntitySheep;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.entity.passive.EntityWolf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.AchievementList;
import net.minecraft.world.storage.loot.LootEntryItem;
import net.minecraft.world.storage.loot.LootPool;
import net.minecraft.world.storage.loot.LootTableList;
import net.minecraft.world.storage.loot.conditions.LootCondition;
import net.minecraft.world.storage.loot.functions.LootFunction;
import net.minecraftforge.event.LootTableLoadEvent;
import net.minecraftforge.event.entity.EntityJoinWorldEvent;
import net.minecraftforge.event.entity.living.LivingSpawnEvent.CheckSpawn;
import net.minecraftforge.event.world.BlockEvent.HarvestDropsEvent;
import net.minecraftforge.fml.client.event.ConfigChangedEvent;
import net.minecraftforge.fml.common.eventhandler.Event.Result;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.PlayerEvent.ItemPickupEvent;
import rainbeau.mithwoodforest.RMFBlocks.BlockMithwoodLeaves;
import rainbeau.mithwoodforest.RMFBlocks.BlocksCreate;
import rainbeau.mithwoodforest.RMFConfig.Config;
import rainbeau.mithwoodforest.RMFEntities.BigCatEntity;
import rainbeau.mithwoodforest.RMFEntities.GuardianEntity;
import rainbeau.mithwoodforest.RMFItems.ItemsCreate;

public class EventHandlerCommon {

	@SubscribeEvent
	public void onCheckSpawn(CheckSpawn event) {
		if (event.getEntity() instanceof BigCatEntity) {
			if (new Random().nextInt(100) < Config.AddBigCats) {
				event.setResult(Result.ALLOW);
			}
			else {
				event.setResult(Result.DENY);
				
			}
		}
		if (event.getEntity() instanceof GuardianEntity) {
			if (new Random().nextInt(100) < Config.AddGuardians) {
				event.setResult(Result.ALLOW);
			}
			else {
				event.setResult(Result.DENY);
			}
		}
	}

	@SubscribeEvent
	public void onConfigChangedEvent(ConfigChangedEvent.OnConfigChangedEvent event) {
		if (event.getModID().equals("mithwoodforest")) {
	        Config.init();
	    }
	}

	@SubscribeEvent
	public void onEntityJoinWorldEvent(EntityJoinWorldEvent event) {
		Entity entity = event.getEntity();
		if (entity != null) {
			if (Config.AddBigCats > 0) {
				if (entity instanceof EntityChicken) {
					EntityChicken chicken = (EntityChicken)event.getEntity();
					chicken.tasks.addTask(4, new EntityAIAvoidEntity(chicken, BigCatEntity.class, 8.0F, 1.4D, 1.8D));
				}
				if (entity instanceof EntityCow) {
					EntityCow cow = (EntityCow)event.getEntity();
					cow.tasks.addTask(4, new EntityAIAvoidEntity(cow, BigCatEntity.class, 8.0F, 1.4D, 1.8D));
				}
				if (entity instanceof EntityPig) {
					EntityPig pig = (EntityPig)event.getEntity();
					pig.tasks.addTask(5, new EntityAIAvoidEntity(pig, BigCatEntity.class, 8.0F, 1.4D, 1.8D));
				}
				if (entity instanceof EntityRabbit) {
					EntityRabbit rabbit = (EntityRabbit)event.getEntity();
					rabbit.tasks.addTask(4, new EntityAIAvoidEntity(rabbit, BigCatEntity.class, 10.0F, 2.2D, 2.2D));
				}
				if (entity instanceof EntitySheep) {
					EntitySheep sheep = (EntitySheep)event.getEntity();
					sheep.tasks.addTask(4, new EntityAIAvoidEntity(sheep, BigCatEntity.class, 8.0F, 1.4D, 1.8D));
				}
				if (entity instanceof EntityVillager) {
					EntityVillager villager = (EntityVillager)event.getEntity();
					villager.tasks.addTask(1, new EntityAIAvoidEntity(villager, BigCatEntity.class, 8.0F, 0.6D, 0.6D));
				}
				if (entity instanceof EntityWolf) {
					EntityWolf wolf = (EntityWolf)event.getEntity();
					wolf.targetTasks.addTask(5, new EntityAINearestAttackableTarget(wolf, BigCatEntity.class, false));
				}
			}
		}
	}

	@SubscribeEvent
	public void onHarvestDropsEvent(HarvestDropsEvent event) {
		Block block = event.getState().getBlock();
		if (block instanceof BlockMithwoodLeaves) {
			if (new Random().nextInt(128) == 0)
				event.getDrops().add(new ItemStack(Items.APPLE));
			if (new Random().nextInt(1024) == 0)
				event.getDrops().add(new ItemStack(Items.GOLDEN_APPLE, 1, 0));
			if (new Random().nextInt(8192) == 0)
				event.getDrops().add(new ItemStack(Items.GOLDEN_APPLE, 1, 1));
		}
	}

	@SubscribeEvent
	public void onItemPickupEvent(ItemPickupEvent event) {
		EntityPlayer player = event.player;
		EntityItem entity = event.pickedUp;
		ItemStack itemstack = entity.getEntityItem();
		if (itemstack != null && itemstack.getItem() == Item.getItemFromBlock(BlocksCreate.mithwood_log)) {
			player.addStat(AchievementList.MINE_WOOD);
		}
	}

    @SubscribeEvent
    public void onLootTableLoadEvent(LootTableLoadEvent event) {
    	if (Config.LapisArmor == true) {
    		if ((event.getName().equals(LootTableList.CHESTS_ABANDONED_MINESHAFT)) || (event.getName().equals(LootTableList.CHESTS_STRONGHOLD_CORRIDOR)) || (event.getName().equals(LootTableList.CHESTS_VILLAGE_BLACKSMITH))) {
    			final LootPool main = event.getTable().getPool("main");
    			if (main != null) {
    				main.addEntry(new LootEntryItem(ItemsCreate.lapis_pickaxe, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:lapis_pickaxe"));
    				main.addEntry(new LootEntryItem(ItemsCreate.lapis_axe, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:lapis_axe"));
    				main.addEntry(new LootEntryItem(ItemsCreate.lapis_sword, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:lapis_sword"));
    				main.addEntry(new LootEntryItem(ItemsCreate.lapis_helmet, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:lapis_helmet"));
    				main.addEntry(new LootEntryItem(ItemsCreate.lapis_chestplate, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:lapis_chestplate"));
    				main.addEntry(new LootEntryItem(ItemsCreate.lapis_leggings, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:lapis_leggings"));
    				main.addEntry(new LootEntryItem(ItemsCreate.lapis_boots, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:lapis_boots"));
    			}
    		}
    	}
    	if (Config.ObsidianArmor == true) {
    		if ((event.getName().equals(LootTableList.CHESTS_ABANDONED_MINESHAFT)) || (event.getName().equals(LootTableList.CHESTS_STRONGHOLD_CORRIDOR)) || (event.getName().equals(LootTableList.CHESTS_NETHER_BRIDGE))) {
    			final LootPool main = event.getTable().getPool("main");
    			if (main != null) {
    				main.addEntry(new LootEntryItem(ItemsCreate.obsidian_helmet, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:obsidian_helmet"));
    				main.addEntry(new LootEntryItem(ItemsCreate.obsidian_chestplate, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:obsidian_chestplate"));
    				main.addEntry(new LootEntryItem(ItemsCreate.obsidian_leggings, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:obsidian_leggings"));
    				main.addEntry(new LootEntryItem(ItemsCreate.obsidian_boots, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:obsidian_boots"));
    			}
    		}
    	}
    	if (Config.EmeraldArmor == true) {
    		if (event.getName().equals(LootTableList.CHESTS_END_CITY_TREASURE)) {
    			final LootPool main = event.getTable().getPool("main");
    			if (main != null) {
    				main.addEntry(new LootEntryItem(ItemsCreate.emerald_pickaxe, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:emerald_pickaxe"));
    				main.addEntry(new LootEntryItem(ItemsCreate.emerald_axe, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:emerald_axe"));
    				main.addEntry(new LootEntryItem(ItemsCreate.emerald_sword, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:emerald_sword"));
    				main.addEntry(new LootEntryItem(ItemsCreate.emerald_helmet, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:emerald_helmet"));
    				main.addEntry(new LootEntryItem(ItemsCreate.emerald_chestplate, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:emerald_chestplate"));
    				main.addEntry(new LootEntryItem(ItemsCreate.emerald_leggings, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:emerald_leggings"));
    				main.addEntry(new LootEntryItem(ItemsCreate.emerald_boots, 1, 0, new LootFunction[0], new LootCondition[0], "mithwoodforest:emerald_boots"));
    			}
    		}
    	}
    }

}
