package rainbeau.mithwoodforest.RMFItems;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.init.MobEffects;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemStack;
import net.minecraft.potion.Potion;
import net.minecraft.potion.PotionEffect;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.registry.GameRegistry;

public class ItemArmorRMF extends ItemArmor {
	
	public ItemArmorRMF(String unlocalizedName, ItemArmor.ArmorMaterial material, EntityEquipmentSlot slot) {
		super(material, 1, slot);
	    this.setUnlocalizedName(unlocalizedName);
	    this.setRegistryName(unlocalizedName);
	    GameRegistry.register(this);
	}
	
	@Override
	public void onArmorTick(World world, EntityPlayer player, ItemStack itemStack) {
		if (player.inventory.armorItemInSlot(3) != null && player.inventory.armorItemInSlot(3).getItem() == ItemsCreate.obsidian_helmet
		    && player.inventory.armorItemInSlot(2) != null && player.inventory.armorItemInSlot(2).getItem() == ItemsCreate.obsidian_chestplate
		    && player.inventory.armorItemInSlot(1) != null && player.inventory.armorItemInSlot(1).getItem() == ItemsCreate.obsidian_leggings
		    && player.inventory.armorItemInSlot(0) != null && player.inventory.armorItemInSlot(0).getItem() == ItemsCreate.obsidian_boots) {
		    effectPlayer(player, MobEffects.FIRE_RESISTANCE, 0);
		}
		if (player.inventory.armorItemInSlot(3) != null && player.inventory.armorItemInSlot(3).getItem() == ItemsCreate.prismarine_helmet) {
		    effectPlayer(player, MobEffects.NIGHT_VISION, 0);
		}
		if (player.inventory.armorItemInSlot(2) != null && player.inventory.armorItemInSlot(2).getItem() == ItemsCreate.prismarine_chestplate) {
		    effectPlayer(player, MobEffects.WATER_BREATHING, 0);
		}
		if (player.inventory.armorItemInSlot(3) != null && player.inventory.armorItemInSlot(3).getItem() == ItemsCreate.mithril_helmet) {
		    effectPlayer(player, MobEffects.HASTE, 0);
		}
		if (player.inventory.armorItemInSlot(2) != null && player.inventory.armorItemInSlot(2).getItem() == ItemsCreate.mithril_chestplate) {
		    effectPlayer(player, MobEffects.RESISTANCE, 0);
		}
		if (player.inventory.armorItemInSlot(1) != null && player.inventory.armorItemInSlot(1).getItem() == ItemsCreate.mithril_leggings) {
		    effectPlayer(player, MobEffects.STRENGTH, 0);
		}
		if (player.inventory.armorItemInSlot(0) != null && player.inventory.armorItemInSlot(0).getItem() == ItemsCreate.mithril_boots) {
		    effectPlayer(player, MobEffects.SPEED, 0);
		}
	}

	private void effectPlayer(EntityPlayer player, Potion potion, int amplifier) {
	    if (player.getActivePotionEffect(potion) == null || player.getActivePotionEffect(potion).getDuration() <= 1)
	        player.addPotionEffect(new PotionEffect(potion, 159, amplifier, true, true));
	}
	
	@Override
	public boolean getIsRepairable(ItemStack toRepair, ItemStack repair) {
		if (toRepair.getItem().equals(ItemsCreate.emerald_helmet) || toRepair.getItem().equals(ItemsCreate.emerald_chestplate)
			|| toRepair.getItem().equals(ItemsCreate.emerald_leggings) || toRepair.getItem().equals(ItemsCreate.emerald_boots)) {
			if (repair.getItem().equals(Items.EMERALD)) {
				return true;
			}
		}
		if (toRepair.getItem().equals(ItemsCreate.lapis_helmet) || toRepair.getItem().equals(ItemsCreate.lapis_chestplate)
			|| toRepair.getItem().equals(ItemsCreate.lapis_leggings) || toRepair.getItem().equals(ItemsCreate.lapis_boots)) {
			if (repair.getItem().equals(ItemsCreate.lapis_ingot)) {
				return true;
			}
		}
		if (toRepair.getItem().equals(ItemsCreate.mithril_helmet) || toRepair.getItem().equals(ItemsCreate.mithril_chestplate)
			|| toRepair.getItem().equals(ItemsCreate.mithril_leggings) || toRepair.getItem().equals(ItemsCreate.mithril_boots)) {
			if (repair.getItem().equals(ItemsCreate.mithril_ingot)) {
				return true;
			}
		}
		if (toRepair.getItem().equals(ItemsCreate.obsidian_helmet) || toRepair.getItem().equals(ItemsCreate.obsidian_chestplate)
			|| toRepair.getItem().equals(ItemsCreate.obsidian_leggings) || toRepair.getItem().equals(ItemsCreate.obsidian_boots)) {
			if (repair.getItem().equals(ItemsCreate.obsidian_ingot)) {
				return true;
			}
		}
		if (toRepair.getItem().equals(ItemsCreate.prismarine_helmet) || toRepair.getItem().equals(ItemsCreate.prismarine_chestplate)
			|| toRepair.getItem().equals(ItemsCreate.prismarine_leggings) || toRepair.getItem().equals(ItemsCreate.prismarine_boots)) {
			if (repair.getItem().equals(Items.PRISMARINE_SHARD)) {
				return true;
			}
		}
		return false;
	}
	
}
