package rainbeau.mithwoodforest.RMFItems;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemPickaxe;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.registry.GameRegistry;
import rainbeau.mithwoodforest.RMFBlocks.BlocksCreate;

public class ItemPickaxeRMF extends ItemPickaxe {
	
	public ItemPickaxeRMF(String unlocalizedName, ToolMaterial material) {
	    super(material);
	    this.setUnlocalizedName(unlocalizedName);
	    this.setRegistryName(unlocalizedName);
	    GameRegistry.register(this);
	}

	@Override
	public boolean canHarvestBlock(IBlockState blockIn) {
		Block block = blockIn.getBlock();
		if (block == BlocksCreate.unobtainium_ore) {
			return this.toolMaterial.getHarvestLevel() >= 4;
		}
		else if (block == Blocks.OBSIDIAN) {
			return this.toolMaterial.getHarvestLevel() >= 3;
		}
		else if (block != Blocks.DIAMOND_BLOCK && block != Blocks.DIAMOND_ORE) {
			if (block != Blocks.EMERALD_ORE && block != Blocks.EMERALD_BLOCK) {
				if (block != Blocks.GOLD_BLOCK && block != Blocks.GOLD_ORE) {
					if (block != Blocks.IRON_BLOCK && block != Blocks.IRON_ORE) {
						if (block != Blocks.LAPIS_BLOCK && block != Blocks.LAPIS_ORE) {
							if (block != Blocks.REDSTONE_ORE && block != Blocks.LIT_REDSTONE_ORE) {
								Material material = blockIn.getMaterial();
								return material == Material.ROCK ? true : (material == Material.IRON ? true : material == Material.ANVIL);
							}
							else {
								return this.toolMaterial.getHarvestLevel() >= 2;
							}
						}
						else {
							return this.toolMaterial.getHarvestLevel() >= 1;
						}
					}
					else {
						return this.toolMaterial.getHarvestLevel() >= 1;
					}
				}
				else {
					return this.toolMaterial.getHarvestLevel() >= 2;
				}
			}
			else {
				return this.toolMaterial.getHarvestLevel() >= 2;
			}
		}
		else {
			return this.toolMaterial.getHarvestLevel() >= 2;
		}
	}

	@Override
	public boolean getIsRepairable(ItemStack toRepair, ItemStack repair) {
		if (toRepair.getItem().equals(ItemsCreate.emerald_pickaxe)) {
			if (repair.getItem().equals(Items.EMERALD)) {
				return true;
			}
		}
		if (toRepair.getItem().equals(ItemsCreate.lapis_pickaxe)) {
			if (repair.getItem().equals(ItemsCreate.lapis_ingot)) {
				return true;
			}
		}
		if (toRepair.getItem().equals(ItemsCreate.obsidian_pickaxe)) {
			if (repair.getItem().equals(ItemsCreate.obsidian_ingot)) {
				return true;
			}
		}
		if (toRepair.getItem().equals(ItemsCreate.prismarine_pickaxe)) {
			if (repair.getItem().equals(Items.PRISMARINE_SHARD)) {
				return true;
			}
		}
		return false;
	}

}
