package rainbeau.mithwoodforest.RMFProxies;

import net.minecraft.block.Block;
import net.minecraft.block.BlockDoor;
import net.minecraft.client.renderer.block.model.ModelBakery;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.renderer.block.statemap.IStateMapper;
import net.minecraft.client.renderer.block.statemap.StateMap;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.entity.Entity;
import net.minecraft.item.Item;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.fml.client.registry.IRenderFactory;
import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import rainbeau.mithwoodforest.RMFBlocks.BlocksModels;
import rainbeau.mithwoodforest.RMFEntities.GuardianEntity;
import rainbeau.mithwoodforest.RMFEntities.GuardianRender;
import rainbeau.mithwoodforest.RMFEntities.LeopardEntity;
import rainbeau.mithwoodforest.RMFEntities.LeopardRender;
import rainbeau.mithwoodforest.RMFEntities.LionEntity;
import rainbeau.mithwoodforest.RMFEntities.LionRender;
import rainbeau.mithwoodforest.RMFEntities.MithwoodTigerEntity;
import rainbeau.mithwoodforest.RMFEntities.MithwoodTigerRender;
import rainbeau.mithwoodforest.RMFEntities.PantherEntity;
import rainbeau.mithwoodforest.RMFEntities.PantherRender;
import rainbeau.mithwoodforest.RMFEntities.SnowLeopardEntity;
import rainbeau.mithwoodforest.RMFEntities.SnowLeopardRender;
import rainbeau.mithwoodforest.RMFEntities.TigerEntity;
import rainbeau.mithwoodforest.RMFEntities.TigerRender;
import rainbeau.mithwoodforest.RMFEvents.EventHandlerClient;
import rainbeau.mithwoodforest.RMFItems.ItemsModels;

public class ProxyClient extends ProxyCommon {

    @Override
    public void preInit(FMLPreInitializationEvent event) { 
    	super.preInit(event);
		ItemsModels.init();
		BlocksModels.init();
		registerEntityRenderer(LeopardEntity.class, LeopardRender.class);
		registerEntityRenderer(LionEntity.class, LionRender.class);
		registerEntityRenderer(MithwoodTigerEntity.class, MithwoodTigerRender.class);
		registerEntityRenderer(PantherEntity.class, PantherRender.class);
		registerEntityRenderer(SnowLeopardEntity.class, SnowLeopardRender.class);
		registerEntityRenderer(TigerEntity.class, TigerRender.class);
		registerEntityRenderer(GuardianEntity.class, GuardianRender.class);
	}
 
    @Override
    public void init(FMLInitializationEvent event) { 
    	super.init(event); 
    	MinecraftForge.EVENT_BUS.register(new EventHandlerClient());
    }

    @Override
    public void postInit(FMLPostInitializationEvent event) { 
    	super.postInit(event); 
    }

    private static <E extends Entity> void registerEntityRenderer(Class<E> entityClass, Class<? extends Render<E>> renderClass) {
        RenderingRegistry.registerEntityRenderingHandler(entityClass, new EntityRenderFactory<E>(renderClass));
    }

    private static class EntityRenderFactory<E extends Entity> implements IRenderFactory<E> {
        private Class<? extends Render<E>> renderClass;
        private EntityRenderFactory(Class<? extends Render<E>> renderClass) {
            this.renderClass = renderClass;
        }
        @Override
        public Render<E> createRenderFor(RenderManager manager) {
            Render<E> renderer = null;
            try {
                renderer = renderClass.getConstructor(RenderManager.class).newInstance(manager);
            } 
            catch (Exception e) {
                e.printStackTrace();
            }
            return renderer;
        }
    }
 
    @Override
    public void registerBlockSided(Block block) {
    	IStateMapper custom_mapper = new StateMap.Builder().ignore(BlockDoor.POWERED).build();
    	ModelLoader.setCustomStateMapper(block, custom_mapper);
    }
          
    @Override
    public void registerItemVariantModel(Item item, String name, int metadata) {
    	if (item != null) {
    		ModelBakery.registerItemVariants(item, new ResourceLocation[] { new ResourceLocation("mithwoodforest:" + name) });
    		ModelLoader.setCustomModelResourceLocation(item, metadata, new ModelResourceLocation("mithwoodforest:" + name, "inventory"));
    	}
    }    	

    @Override
    public void registerItemSided(Item item) {
        ModelLoader.setCustomModelResourceLocation(item, 0, new ModelResourceLocation("mithwoodforest:" + item.delegate.name().getResourcePath(), "inventory"));
    }
 
}
