package rainbeau.mithwoodforest.RMFProxies;

import com.google.common.base.Optional;

import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.world.biome.Biome;
import net.minecraftforge.common.BiomeDictionary;
import net.minecraftforge.common.BiomeDictionary.Type;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.registry.GameRegistry;
import rainbeau.mithwoodforest.RMFBlocks.BlocksCreate;
import rainbeau.mithwoodforest.RMFBlocks.BlocksHarvestLevels;
import rainbeau.mithwoodforest.RMFConfig.Config;
import rainbeau.mithwoodforest.RMFEntities.EntitiesBiomes;
import rainbeau.mithwoodforest.RMFEntities.EntitiesCreate;
import rainbeau.mithwoodforest.RMFEvents.EventHandlerCommon;
import rainbeau.mithwoodforest.RMFItems.ItemsCreate;
import rainbeau.mithwoodforest.RMFRecipes.Recipes;
import rainbeau.mithwoodforest.RMFWorldGen.BiomesRMF;
import rainbeau.mithwoodforest.RMFWorldGen.WorldGen;

public class ProxyCommon {

    public void preInit(FMLPreInitializationEvent event) {
		BlocksCreate.init();
		ItemsCreate.init();
		EntitiesCreate.init();
    }

    public void init(FMLInitializationEvent event) {
    	BiomesRMF.init();
		if (Config.GrowMithwoodForest == true) {
			BiomeDictionary.registerBiomeType(BiomesRMF.mithwoodForest, Type.FOREST, Type.MAGICAL);
		}
    	if (Config.MithrilArmor == true && (Config.EmeraldArmor == true || Config.PrismarineArmor == true)) {
			GameRegistry.registerWorldGenerator(new WorldGen(), 0);
		}
    	MinecraftForge.EVENT_BUS.register(new EventHandlerCommon());
    }

    public void postInit(FMLPostInitializationEvent event) {
    	EntitiesBiomes.init();
    	BlocksHarvestLevels.init();
		Recipes.init();
    }
  
    public void registerBlockSided(Block block) {}

    public void registerItemVariantModel(Item item, String name, int metadata) {}
 
    public void registerItemSided(Item item) {}
  
}
