package rainbeau.mithwoodforest.RMFRecipes;

import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.registry.GameRegistry;
import rainbeau.mithwoodforest.RMFBlocks.BlocksCreate;
import rainbeau.mithwoodforest.RMFConfig.Config;
import rainbeau.mithwoodforest.RMFItems.ItemsCreate;

public class Recipes {
	
	public static void init() {
		if (Config.GrowMithwoodForest == true) {
			GameRegistry.addSmelting(BlocksCreate.mithwood_log, new ItemStack(Items.COAL, 1, 1), 0.5F);
			GameRegistry.addShapelessRecipe(new ItemStack(BlocksCreate.mithwood_plank, 4), new Object[] { BlocksCreate.mithwood_log } );
		    GameRegistry.addRecipe(new ItemStack(BlocksCreate.mithwood_slab_single, 6), new Object[] { "XXX", Character.valueOf('X'), BlocksCreate.mithwood_plank });
		    GameRegistry.addRecipe(new ItemStack(BlocksCreate.mithwood_stairs, 4), new Object[] { "  X", " XX", "XXX", Character.valueOf('X'), BlocksCreate.mithwood_plank });
			GameRegistry.addRecipe(new ItemStack(BlocksCreate.mithwood_fencegate, 1), new Object[] { "   ", "SPS", "SPS", 'S', Items.STICK, 'P', BlocksCreate.mithwood_plank });
			GameRegistry.addRecipe(new ItemStack(BlocksCreate.mithwood_fence, 3), new Object[] { "   ", "PSP", "PSP", 'S', Items.STICK, 'P', BlocksCreate.mithwood_plank });
		}
		if (Config.EmeraldArmor == true) {
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.emerald_pickaxe), new Object[] { 
				"III", 
				" S ", 
				" S ", 'I', Items.EMERALD, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.emerald_axe), new Object[] { 
				"II ", 
				"IS ", 
				" S ", 'I', Items.EMERALD, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.emerald_spade), new Object[] { 
				" I ", 
				" S ", 
				" S ", 'I', Items.EMERALD, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.emerald_hoe), new Object[] { 
				"II ", 
				" S ", 
				" S ", 'I', Items.EMERALD, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.emerald_sword), new Object[] { 
				" I ", 
				" I ", 
				" S ", 'I', Items.EMERALD, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.emerald_helmet), new Object[] { 
				"III", 
				"I I", 
				"   ", 'I', Items.EMERALD });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.emerald_chestplate), new Object[] { 
				"I I", 
				"III", 
				"III", 'I', Items.EMERALD });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.emerald_leggings), new Object[] { 
				"III", 
				"I I", 
				"I I", 'I', Items.EMERALD });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.emerald_boots), new Object[] { 
				"   ", 
				"I I", 
				"I I", 'I', Items.EMERALD });
			if (Config.Paxels == true) {
				GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.emerald_paxel), new Object[] { 
					"IPI", 
					"SRH",	 	
					"IAI", 'I', Items.EMERALD, 'P', ItemsCreate.emerald_pickaxe, 'A', ItemsCreate.emerald_axe, 'S', ItemsCreate.emerald_spade, 'H', ItemsCreate.emerald_hoe, 'R', Items.REDSTONE });		
			}
			if (Config.ArmorToIngots == true) {
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.emerald_helmet), new ItemStack(Items.EMERALD, 3), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.emerald_chestplate), new ItemStack(Items.EMERALD, 5), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.emerald_leggings), new ItemStack(Items.EMERALD, 5), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.emerald_boots), new ItemStack(Items.EMERALD, 3), 0.5F);
			}
		}
		if (Config.LapisArmor == true) {
			GameRegistry.addSmelting(Blocks.LAPIS_BLOCK, new ItemStack(ItemsCreate.lapis_ingot), 1.0F);
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.lapis_pickaxe), new Object[] { 
				"III", 
				" S ", 
				" S ", 'I', ItemsCreate.lapis_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.lapis_axe), new Object[] { 
				"II ", 
				"IS ", 
				" S ", 'I', ItemsCreate.lapis_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.lapis_spade), new Object[] { 
				" I ", 
				" S ",
				" S ", 'I', ItemsCreate.lapis_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.lapis_hoe), new Object[] { 
				"II ", 
				" S ", 
				" S ", 'I', ItemsCreate.lapis_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.lapis_sword), new Object[] { 
				" I ", 
				" I ", 
				" S ", 'I', ItemsCreate.lapis_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.lapis_helmet), new Object[] { 
				"III", 
				"I I", 
				"   ", 'I', ItemsCreate.lapis_ingot });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.lapis_chestplate), new Object[] { 
				"I I", 
				"III", 
				"III", 'I', ItemsCreate.lapis_ingot });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.lapis_leggings), new Object[] { 
				"III", 
				"I I", 
				"I I", 'I', ItemsCreate.lapis_ingot });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.lapis_boots), new Object[] { 
				"   ", 
				"I I", 
				"I I", 'I', ItemsCreate.lapis_ingot });
			if (Config.Paxels == true) {
				GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.lapis_paxel), new Object[] { 
					"IPI", 
					"SRH", 
					"IAI", 'I', ItemsCreate.lapis_ingot, 'P', ItemsCreate.lapis_pickaxe, 'A', ItemsCreate.lapis_axe, 'S', ItemsCreate.lapis_spade, 'H', ItemsCreate.lapis_hoe, 'R', Items.REDSTONE });		
			}
			if (Config.ArmorToIngots == true) {
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.lapis_helmet), new ItemStack(ItemsCreate.lapis_ingot, 3), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.lapis_chestplate), new ItemStack(ItemsCreate.lapis_ingot, 5), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.lapis_leggings), new ItemStack(ItemsCreate.lapis_ingot, 5), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.lapis_boots), new ItemStack(ItemsCreate.lapis_ingot, 3), 0.5F);
			}
		}
		if (Config.MithrilArmor == true && (Config.EmeraldArmor == true || Config.PrismarineArmor == true)) {
			GameRegistry.addSmelting(BlocksCreate.unobtainium_ore, new ItemStack(ItemsCreate.mithril_ingot), 1.0F);
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.mithril_pickaxe), new Object[] { 
				"III", 
				" S ", 
				" S ", 'I', ItemsCreate.mithril_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.mithril_axe), new Object[] { 
				"II ", 
				"IS ", 
				" S ", 'I', ItemsCreate.mithril_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.mithril_spade), new Object[] { 
				" I ", 
				" S ", 
				" S ", 'I', ItemsCreate.mithril_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.mithril_hoe), new Object[] { 
				"II ", 
				" S ", 
				" S ", 'I', ItemsCreate.mithril_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.mithril_sword), new Object[] { 
				" I ", 
				" I ", 
				" S ", 'I', ItemsCreate.mithril_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.mithril_helmet), new Object[] { 
				"III", 
				"I I", 
				"   ", 'I', ItemsCreate.mithril_ingot });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.mithril_chestplate), new Object[] { 
				"I I", 
				"III", 
				"III", 'I', ItemsCreate.mithril_ingot });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.mithril_leggings), new Object[] { 
				"III", 
				"I I", 
				"I I", 'I', ItemsCreate.mithril_ingot });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.mithril_boots), new Object[] { 
				"   ", 
				"I I", 
				"I I", 'I', ItemsCreate.mithril_ingot });
			if (Config.Paxels == true) {
				GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.mithril_paxel), new Object[] { 
					"IPI", 
					"SRH", 
					"IAI", 'I', ItemsCreate.mithril_ingot, 'P', ItemsCreate.mithril_pickaxe, 'A', ItemsCreate.mithril_axe, 'S', ItemsCreate.mithril_spade, 'H', ItemsCreate.mithril_hoe, 'R', Items.REDSTONE });		
			}
			if (Config.ArmorToIngots == true) {
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.mithril_helmet), new ItemStack(ItemsCreate.mithril_ingot, 3), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.mithril_chestplate), new ItemStack(ItemsCreate.mithril_ingot, 5), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.mithril_leggings), new ItemStack(ItemsCreate.mithril_ingot, 5), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.mithril_boots), new ItemStack(ItemsCreate.mithril_ingot, 3), 0.5F);
			}
		}
		if (Config.ObsidianArmor == true) {
			GameRegistry.addShapelessRecipe(new ItemStack(ItemsCreate.obsidian_ingot), new Object[] { Blocks.OBSIDIAN, Items.QUARTZ });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.obsidian_pickaxe), new Object[] { 
				"III", 
				" S ", 
				" S ", 'I', ItemsCreate.obsidian_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.obsidian_axe), new Object[] { 
				"II ", 
				"IS ", 
				" S ", 'I', ItemsCreate.obsidian_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.obsidian_spade), new Object[] { 
				" I ", 
				" S ", 
				" S ", 'I', ItemsCreate.obsidian_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.obsidian_hoe), new Object[] { 
				"II ", 
				" S ", 
				" S ", 'I', ItemsCreate.obsidian_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.obsidian_sword), new Object[] { 
				" I ", 
				" I ", 
				" S ", 'I', ItemsCreate.obsidian_ingot, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.obsidian_helmet), new Object[] { 
				"III", 
				"I I", 
				"   ", 'I', ItemsCreate.obsidian_ingot });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.obsidian_chestplate), new Object[] { 
				"I I", 
				"IBI", 
				"III", 'I', ItemsCreate.obsidian_ingot, 'B', Items.BLAZE_ROD });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.obsidian_leggings), new Object[] { 
				"III", 
				"I I", 
				"I I", 'I', ItemsCreate.obsidian_ingot });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.obsidian_boots), new Object[] { 
				"   ", 
				"I I", 
				"I I", 'I', ItemsCreate.obsidian_ingot });
			if (Config.Paxels == true) {
				GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.obsidian_paxel), new Object[] { 
					"IPI", 
					"SRH", 
					"IAI", 'I', ItemsCreate.obsidian_ingot, 'P', ItemsCreate.obsidian_pickaxe, 'A', ItemsCreate.obsidian_axe, 'S', ItemsCreate.obsidian_spade, 'H', ItemsCreate.obsidian_hoe, 'R', Items.REDSTONE });		
			}
			if (Config.ArmorToIngots == true) {
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.obsidian_helmet), new ItemStack(ItemsCreate.obsidian_ingot, 3), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.obsidian_chestplate), new ItemStack(ItemsCreate.obsidian_ingot, 5), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.obsidian_leggings), new ItemStack(ItemsCreate.obsidian_ingot, 5), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.obsidian_boots), new ItemStack(ItemsCreate.obsidian_ingot, 3), 0.5F);
			}
		}
		if (Config.PrismarineArmor == true) {
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.prismarine_pickaxe), new Object[] { 
				"III", 
				" S ", 
				" S ", 'I', Items.PRISMARINE_SHARD, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.prismarine_axe), new Object[] { 
				"II ", 
				"IS ", 
				" S ", 'I', Items.PRISMARINE_SHARD, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.prismarine_spade), new Object[] { 
				" I ", 
				" S ", 
				" S ", 'I', Items.PRISMARINE_SHARD, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.prismarine_hoe), new Object[] { 
				"II ", 
				" S ", 
				" S ", 'I', Items.PRISMARINE_SHARD, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.prismarine_sword), new Object[] { 
				" I ", 
				" I ", 
				" S ", 'I', Items.PRISMARINE_SHARD, 'S', Items.STICK });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.prismarine_helmet), new Object[] { 
				"III", 
				"I I", 
				"   ", 'I', Items.PRISMARINE_SHARD });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.prismarine_chestplate), new Object[] { 
				"I I", 
				"III", 
				"III", 'I', Items.PRISMARINE_SHARD });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.prismarine_leggings), new Object[] { 
				"III", 
				"I I", 
				"I I", 'I', Items.PRISMARINE_SHARD });
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.prismarine_boots), new Object[] { 
				"   ", 
				"I I", 
				"I I", 'I', Items.PRISMARINE_SHARD });
			if (Config.Paxels == true) {
				GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.prismarine_paxel), new Object[] { 
					"IPI", 
					"SRH", 
					"IAI", 'I', Items.PRISMARINE_SHARD, 'P', ItemsCreate.prismarine_pickaxe, 'A', ItemsCreate.prismarine_axe, 'S', ItemsCreate.prismarine_spade, 'H', ItemsCreate.prismarine_hoe, 'R', Items.REDSTONE });		
			}
			if (Config.ArmorToIngots == true) {
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.prismarine_helmet), new ItemStack(Items.PRISMARINE_SHARD, 3), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.prismarine_chestplate), new ItemStack(Items.PRISMARINE_SHARD, 5), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.prismarine_leggings), new ItemStack(Items.PRISMARINE_SHARD, 5), 0.5F);
				GameRegistry.addSmelting(new ItemStack(ItemsCreate.prismarine_boots), new ItemStack(Items.PRISMARINE_SHARD, 3), 0.5F);
			}
		}
		if (Config.Paxels == true) {
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.iron_paxel), new Object[] { 
				"IPI", 
				"SRH", 
				"IAI", 'I', Items.IRON_INGOT, 'P', Items.IRON_PICKAXE, 'A', Items.IRON_AXE, 'S', Items.IRON_SHOVEL, 'H', Items.IRON_HOE, 'R', Items.REDSTONE });		
			GameRegistry.addShapedRecipe(new ItemStack(ItemsCreate.diamond_paxel), new Object[] { 
				"IPI", 
				"SRH", 
				"IAI", 'I', Items.DIAMOND, 'P', Items.DIAMOND_PICKAXE, 'A', Items.DIAMOND_AXE, 'S', Items.DIAMOND_SHOVEL, 'H', Items.DIAMOND_HOE, 'R', Items.REDSTONE });		
		}
		if (Config.ArmorToIngots == true) {
			GameRegistry.addSmelting(new ItemStack(Items.GOLDEN_HELMET), new ItemStack(Items.GOLD_INGOT, 3), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.GOLDEN_CHESTPLATE), new ItemStack(Items.GOLD_INGOT, 5), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.GOLDEN_LEGGINGS), new ItemStack(Items.GOLD_INGOT, 5), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.GOLDEN_BOOTS), new ItemStack(Items.GOLD_INGOT, 3), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.IRON_HELMET), new ItemStack(Items.IRON_INGOT, 3), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.IRON_CHESTPLATE), new ItemStack(Items.IRON_INGOT, 5), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.IRON_LEGGINGS), new ItemStack(Items.IRON_INGOT, 5), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.IRON_BOOTS), new ItemStack(Items.IRON_INGOT, 3), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.DIAMOND_HELMET), new ItemStack(Items.DIAMOND, 3), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.DIAMOND_CHESTPLATE), new ItemStack(Items.DIAMOND, 5), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.DIAMOND_LEGGINGS), new ItemStack(Items.DIAMOND, 5), 0.5F);
			GameRegistry.addSmelting(new ItemStack(Items.DIAMOND_BOOTS), new ItemStack(Items.DIAMOND, 3), 0.5F);
		}
		if (Config.ChainRecipes == true) {
			GameRegistry.addShapedRecipe(new ItemStack(Items.CHAINMAIL_HELMET), new Object[] { 
				"III", 
				"L L", 
				"   ", 'I', Items.IRON_INGOT, 'L', Items.LEATHER });
			GameRegistry.addShapedRecipe(new ItemStack(Items.CHAINMAIL_CHESTPLATE), new Object[] { 
				"L L", 
				"LIL", 
				"III", 'I', Items.IRON_INGOT, 'L', Items.LEATHER });
			GameRegistry.addShapedRecipe(new ItemStack(Items.CHAINMAIL_LEGGINGS), new Object[] { 
				"III", 
				"L L", 
				"L L", 'I', Items.IRON_INGOT, 'L', Items.LEATHER });
			GameRegistry.addShapedRecipe(new ItemStack(Items.CHAINMAIL_BOOTS), new Object[] { 
				"   ", 
				"L L", 
				"I I", 'I', Items.IRON_INGOT, 'L', Items.LEATHER });
			if (Config.ArmorToIngots == true) {
				GameRegistry.addSmelting(new ItemStack(Items.CHAINMAIL_HELMET), new ItemStack(Items.IRON_INGOT, 2), 0.5F);
				GameRegistry.addSmelting(new ItemStack(Items.CHAINMAIL_CHESTPLATE), new ItemStack(Items.IRON_INGOT, 3), 0.5F);
				GameRegistry.addSmelting(new ItemStack(Items.CHAINMAIL_LEGGINGS), new ItemStack(Items.IRON_INGOT, 2), 0.5F);
				GameRegistry.addSmelting(new ItemStack(Items.CHAINMAIL_BOOTS), new ItemStack(Items.IRON_INGOT), 0.5F);
			}
		}
	}	
	
}
