package rainbeau.mithwoodforest.RMFWorldGen;

import java.util.Random;

import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.biome.BiomeForest;
import net.minecraft.world.biome.BiomeTaiga;
import net.minecraft.world.chunk.IChunkGenerator;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.gen.feature.WorldGenMinable;
import net.minecraft.world.gen.feature.WorldGenerator;
import net.minecraftforge.fml.common.IWorldGenerator;
import rainbeau.mithwoodforest.RMFBlocks.BlocksCreate;
import rainbeau.mithwoodforest.RMFConfig.Config;

public class WorldGen implements IWorldGenerator {
	
	private WorldGenerator generateUnobtainiumOre; 

	public WorldGen() {
	    this.generateUnobtainiumOre = new WorldGenMinable(BlocksCreate.unobtainium_ore.getDefaultState(), 4);
	}

	@Override
	public void generate(Random random, int chunkX, int chunkZ, World world, IChunkGenerator chunkGenerator, IChunkProvider chunkProvider) {
	    switch (world.provider.getDimension()) {
	    	case 0: // Overworld
	    		if (Config.MithrilArmor == true && (Config.EmeraldArmor == true || Config.PrismarineArmor == true)) {
	    			int x = chunkX*16+8;
	    	        int y = 64;
	    	        int z = chunkZ*16+8;
	    			Biome biome = world.getBiomeGenForCoords(new BlockPos(x, y, z));
                    String biomeName = biome.getBiomeName();
    				if (biome instanceof BiomeMithwoodForest) {
    					this.runGenerator(this.generateUnobtainiumOre, world, random, chunkX, chunkZ, 8, 32, 128);
    				}
    				else if ((biomeName.contains("Forest")) || (biomeName.contains("forest"))
                    	|| (biomeName.contains("Woods")) || (biomeName.contains("woods"))
                    	|| (biome instanceof BiomeForest) || (biome instanceof BiomeTaiga)) {
    					this.runGenerator(this.generateUnobtainiumOre, world, random, chunkX, chunkZ, 2, 32, 128);
    				}
	    		}
	    		break;
	    	case -1: // Nether
	    		break;
	    	case 1: // End
	    		break;
	    }
	}

	private void runGenerator(WorldGenerator generator, World world, Random rand, int chunk_X, int chunk_Z, int chancesToSpawn, int minHeight, int maxHeight) {
		if (minHeight < 1) { 
			minHeight = 1; 
		}
		if (maxHeight < minHeight) { 
			maxHeight = minHeight + 1; 
		}
		if (maxHeight > 256) { 
			maxHeight = 256; 
		}
	    int heightDiff = maxHeight - minHeight + 1;
	    for (int i = 0; i < chancesToSpawn; i ++) {
	        int x = chunk_X * 16 + rand.nextInt(16);
	        int y = minHeight + rand.nextInt(heightDiff);
	        int z = chunk_Z * 16 + rand.nextInt(16);
	        generator.generate(world, rand, new BlockPos(x, y, z));
	    }
	}

}
